program InterpretMolpro
	
	integer :: i = 0
	integer :: j = 0
	
	! from simul
	real*8, dimension(:,:), allocatable :: calculated
	character(2), dimension(:), allocatable :: element
	
	! from ini
	integer :: memory
	character(10) :: accuracy
	character(50) :: methode
	character(50) :: base
	
	integer :: atm_count
	integer :: charge,spin
	
	character(3) :: parse
	integer :: parse_int = 1

	character(10) :: optim_method
	integer	      :: conv_maxit
	real*8	:: conv_gradient
	real*8	:: conv_energy
	real*8	:: conv_step

	open (unit = 4, file = "tmp_inter_input")
	open (unit = 2, file = "tmp_simul_output.xyz")
	open (unit = 3, file = "start.ini")

		do while (parse_int /= 4)
		    read (3, *) parse
		    
		    if (parse == "===") then
			if (parse_int == 1) then ! prvni cteni - simul
			    parse_int = 2
			else if (parse_int == 2) then ! druhe cteni - inter
			    read (3, *) memory
			    read (3, *) accuracy
			    read (3, *) base
			    
			    read (3, '(A50)') methode
			    
			    read (3, *) optim_method
			    read (3, *) conv_maxit, conv_gradient, conv_energy, conv_step
			    
					    
			    parse_int = 3
	    		else if (parse_int == 3) then ! treti cteni - molekula
			    read (3, *) charge
			    read (3, *) spin
			    read (3, *) atm_count
	    		    parse_int = 4
	    		end if
		    end if
		    
		end do
		
			
	    write (4, *) "***,", atm_count, "-atom molecule\n"		
	    write (4, *) "memory,", memory, ",m;\n"
	    write (4, *) "gthresh,energy=", accuracy, "\n"
			    

	    allocate (calculated(atm_count, 3))
	    allocate (element(atm_count))

	read (2, *) atm_count
	read (2, *) parse
	
	j = 1
	do while (j <= atm_count)
	    read (2, *) element(j), calculated(j, 1), calculated(j, 2), calculated(j, 3)

	    write (4, '(A, I1, A, $)') "A", j, "x = ["
	    write (4, '(F15.7, A4, $)') calculated(j, 1), "E+00"
	    write (4, *) "]"
		
	    write (4, '(A, I1, A, $)') "A", j, "y = ["
	    write (4, '(F15.7, A4, $)') calculated(j, 2), "E+00"
	    write (4, *) "]"

	    write (4, '(A, I1, A, $)') "A", j, "z = ["
	    write (4, '(F15.7, A4, $)') calculated(j, 3), "E+00"
	    write (4, *) "]"	
	    
		j = j + 1
	    end do

	    write (4, *) "geometry={\n ang"
	    
	    i = 1
	    do while (i <= atm_count)
		write (4, '(A2, ",,xx", I1, ",yy", I1, ",zz", I1)') element(i), i, i, i
		i = i + 1
	    end do
		write (4, *) "}"

		write (4, *) "PROC CalcEnergs"

		write (4, *) "DO i=1,#A1x"

	    i = 1
	    do while (i <= atm_count)
		write (4, '("xx", I1, "=A", I1, "x(i)")') i, i
		write (4, '("yy", I1, "=A", I1, "y(i)")') i, i
		write (4, '("zz", I1, "=A", I1, "z(i)")') i, i
		
		i = i + 1
	    end do
	
	    if (charge /= 0) then
		write (4, '("SET,CHARGE=", I1, ",SPIN=",I1)') charge,spin
	    end if	
		

!	    write (4, *) methode, ";method = program;optg, method=", optim_method, ", MAXIT=", conv_maxit, ", GRADIENT=", conv_gradient, ",ENERGY=", conv_energy, "STEP=", conv_step

	    write (4, '(A50,";method = program;optg, method=",A10,", MAXIT=",I4,", GRADIENT=",E20.10,",ENERGY=",E20.10,", STEP=",E20.10)') methode, optim_method, conv_maxit, conv_gradient, conv_energy, conv_step
	
	    write (4, *) " energ(i)=energy"

	    write (4, *) "ENDDO"

	    write (4, *) " table,energ"
	    
	    write (4, *) "title,XYZ $xx1"
	    i = 1
	    do while (i <= atm_count)
!		write (4, *) "title,$xx", i, " $yy", i, " $zz", i
		write (4, '("title,$xx", I1, " $yy", I1, " $zz", I1)') i, i, i
		i = i + 1
	    end do
	    
	         
	    write (4, *) " save,tmp_inter_output"
	    write (4, *) "ENDPROC"


	    write (4, *) "BASIS,DEFAULT=", base
	    write (4, *) "CalcEnergs"
	    write (4, *) " ---"

    
	    
	    close(4)
	    close(3)
	    close(2)	    
end program
