program simul

    ! Basin hopping 
    
    real*8 :: step
    real*8 :: step_start
    
    real*8 :: acc_ratio_start
    real*8 :: acc_ratio
    integer :: cfg_accepted
    integer :: cfg_denied
    integer :: acc_ratio_periode
    real*8 :: step_multiplier
    
    real*8 :: eng_optim
    real*8 :: eng_curr
    
    integer :: atm_selected
    
    real*8 :: temperature
    real*8 :: random_real
    real*8 :: probability
    real*8 :: e_num
    real*8 :: b_num

    real*8 :: radius
    real*8 :: centroid(3)
    
    integer :: simul_status = 1
    integer :: inter_status

    real*8 :: result_optim
    real*8 :: result_best
	
    integer :: i
    integer :: j
    character(3) :: parse
    integer :: return = 0
	
    integer :: atm_count
    integer :: charge
    real*8, dimension(:,:), allocatable 	:: atm_pos_optim
    real*8, dimension(:,:), allocatable 	:: atm_pos_curr
    real*8, dimension(:,:), allocatable		:: atm_pos_new
    character(2), dimension(:), allocatable	:: element

    real*8	:: tmp_real(3)
    integer	:: tmp_int

    integer :: iter_max
    integer :: iter
    
    integer, dimension(:), allocatable :: seed_new
    integer :: seed_count
    
	
    open (unit = 1, file = "tmp_save" )
	read (1, *) step, iter
	read (1, *) cfg_accepted, cfg_denied
	
	call random_seed(SIZE=seed_count) ! zjistit pocet seedu
    	allocate(seed_new(seed_count))
    	
    	if (iter > 0) then
	    i = 1
    	    do while (i <= seed_count)
    		read (1, *) seed_new(i)
    	
    		i = i + 1
    	    end do
    	end if
	
	
	
	if (iter == 0) then
	    call random_seed()
	else
	    call random_seed(PUT=seed_new(1:seed_count))
	end if
	
	

	close (1)



    open (unit = 3, file = "start.ini")

	tmp_int = 1	
	do while (tmp_int /= 4)
	read (3, *) parse
	        
	if (parse == "===") then
	    if (tmp_int == 1) then ! prvni cteni - simul
		read (3, *) step_start, iter_max
		read (3, *) acc_ratio_start, acc_ratio_periode, step_multiplier
		read (3, *) temperature
		read (3, *) radius
		tmp_int = 2
	    else if (tmp_int == 2) then ! druhe cteni - inter
		tmp_int = 3
	    else if (tmp_int == 3) then ! treti cteni - molekula
		read (3, *) charge
		read (3, *) charge
		
		read (3, *) atm_count
		allocate(atm_pos_optim(atm_count, 3))
		allocate(atm_pos_curr(atm_count, 3))
		allocate(atm_pos_new(atm_count, 3))
		allocate(element(atm_count))
		    
		i = 1
		do while (i <= atm_count)
		    read (3, *) element(i), atm_pos_curr(i, 1), atm_pos_curr(i, 2), atm_pos_curr(i, 3)
		    i = i + 1
		end do
		    
		tmp_int = 4
		end if
	    end if
	end do
	close (3)		
	
	if (iter == 0) then
	    step = step_start
	end if	    	    			    			    												    			    	    	    
	
    if (iter > 0) then !! n-ty nastrel; n != 0

	
	open (unit = 11, file = "tmp_pos_curr.xyz" )	
	    read (11, *) atm_count
	    read (11, *) tmp_real(3)
			
	    j = 1				
	    do while (j <= atm_count)
		read (11, *) element(j), atm_pos_curr(j, 1), atm_pos_curr(j, 2), atm_pos_curr(j, 3)
	        j = j + 1
	    end do
	    close (11)	

	open (unit = 111, file = "tmp_inter_status" )
	    read (111, *) inter_status
	close (111)

	if ((iter == 1) .and. (inter_status == 0)) then ! nepouzitelny nastrel, nema smysl pokracovat
	    return = 3
	end if
	
	if (inter_status == 1) then
	    
	    if (iter > 1) then !! Nacti nejlepsi zatim znamou konfiguraci
		open (unit = 99, file = "best_eng.xyz")
		    read (99, *) atm_count
		    read (99, *) tmp_real(3), result_best
	
		    close (99)
	    end if

	    open (unit = 11, file = "tmp_simul_input.xyz" )	
		read (11, *) atm_count
		read (11, *) tmp_real(2), result_optim
			
		j = 1				
		do while (j <= atm_count)
		    read (11, *) element(j), atm_pos_optim(j, 1), atm_pos_optim(j, 2), atm_pos_optim(j, 3)
	    	    j = j + 1
		end do
		close (11)		    

	
	
	    call random_number(random_real)
	    
	    b_num = 1.380662D-23/4.3597805D-18
	    
	    probability = dexp( -((result_optim - result_best)/(temperature * b_num)))
	    
	    if ( (probability > random_real) .or. (iter == 1)) then
		result_best = result_optim
		
		open (unit = 99, file = "best_eng.xyz")
		write (99, *) atm_count
    		write (99, '("0 ", F15.7, "  Ep=", F15.7, " Ek=  0")') result_optim, result_optim
		 
		i = 1
		do while (i <= atm_count)
		    write (99, '(A2, "  ", F15.7, "  ", F15.7, "  ", F15.7)') element(i), atm_pos_optim(i, 1), atm_pos_optim(i, 2), atm_pos_optim(i, 3)
		    i = i + 1
		end do
		close (99)			
		
		open (unit = 11, file = "tmp_simul_output.xyz" )	
		
		read (11, *) atm_count
		read (11, *) tmp_real(3)
		
		j = 1					
		do while (j <= atm_count)
		    read (11, *) element(j), atm_pos_curr(j, 1), atm_pos_curr(j, 2), atm_pos_curr(j, 3)
	    	    j = j + 1
		end do
		close (11)	
		
		cfg_accepted = cfg_accepted + 1
	    else
		cfg_denied = cfg_denied + 1
	    end if

	else ! inter skoncil ^ dobre
	    cfg_denied = cfg_denied + 1 ! po havarii interaktu zamitnout cfg
	end if	

	if (MODULO(iter, acc_ratio_periode) == 0) then
	    acc_ratio = (cfg_accepted/(cfg_accepted+cfg_denied))
	    
	    if (acc_ratio < acc_ratio_start) then
	        step = step / step_multiplier
	    else
	        step = step * step_multiplier
	    end if
	    
		cfg_accepted = 0
		cfg_denied = 0
	    end if
			
    end if

    !! kontrola hranicnich hodnot
    if (iter == iter_max) then
	return = 2
    end if
    
    !! tvorba okoli
    
    
    call random_number(tmp_real(1))
    atm_selected = int(tmp_real(1)*atm_count)+1
    
    
    open (unit = 22, file = "tmp_simul_output.xyz")

    write (22, '(I)') atm_count
    write (22, *)  iter, "0  Ep=  0 Ek=  0"

    j = 1
    
    do while (j <= atm_count)
    
	if(j == atm_selected) then

    	    if (iter == 0) then !! konfigurace nulte iterace bude konf. ze start.ini
    	        tmp_real(1) = 0
    		tmp_real(2) = 0
    		tmp_real(3) = 0
    	    else ! v n-te iteraci generuji nahodny posun atomu
	        call random_number(tmp_real(1))
	        tmp_real(1)=step*(tmp_real(1)*2.0d0 - 1.0d0)
	        call random_number(tmp_real(2))
	        tmp_real(2)=step*(tmp_real(2)*2.0d0 - 1.0d0)
	        call random_number(tmp_real(3))
	        tmp_real(3)=step*(tmp_real(3)*2.0d0 - 1.0d0)
	    end if

	    ! nove pozice vybraneho atomu
	    atm_pos_new(j, 1) =  atm_pos_curr(j, 1)+tmp_real(1)
	    atm_pos_new(j, 2) =  atm_pos_curr(j, 2)+tmp_real(2)
	    atm_pos_new(j, 3) =  atm_pos_curr(j, 3)+tmp_real(3)
    		
	else
	    ! "nove" pozice nemeneneho atomu
	    atm_pos_new(j, 1) =  atm_pos_curr(j, 1)
	    atm_pos_new(j, 2) =  atm_pos_curr(j, 2)
	    atm_pos_new(j, 3) =  atm_pos_curr(j, 3)
	end if
	    
    	write (22, '(A2, "  ", F15.7, "  ", F15.7, "  ", F15.7)') element(j), atm_pos_new(j, 1), atm_pos_new(j, 2), atm_pos_curr(j, 3)	    		
	centroid(1) = centroid(1) + atm_pos_new(j, 1)
	centroid(2) = centroid(2) + atm_pos_new(j, 2)
	centroid(3) = centroid(3) + atm_pos_new(j, 3)
	
	j = j + 1
    end do
    close (22)	
	
    ! kontrola umisteni cfg v kouli
    centroid(1) = centroid(1)/atm_count
    centroid(2) = centroid(2)/atm_count
    centroid(3) = centroid(3)/atm_count
	
    j = 1
    tmp_int = 1 ! prepinac "vse je v kontejneru? - 1 = ano"
	
    do while ((j <= atm_count) .and. (tmp_int == 1))
	if ( ((atm_pos_new(j, 1)-centroid(1))**2 + (atm_pos_new(j, 2)-centroid(2))**2 + (atm_pos_new(j, 3)-centroid(3))**2) > radius**2 ) then
    	    tmp_int = 0
	end if
	    
	j = j + 1
    end do
	
    if (tmp_int == 0) then ! chybna cfg
	if (iter == 0) then
	    return = 3 ! nastrel je chybny
	else
	    cfg_denied = cfg_denied + 1
	    simul_status = 0
	end if
    else ! spravna cfg, zapisuji nove pos_curr
	open (unit = 99, file = "tmp_pos_curr.xyz")
	    write (99, *) atm_count
	    write (99, '("0 ", F15.7, "  Ep=", F15.7, " Ek=  0")') 0.0, 0.0
		 
	    i = 1
	    do while (i <= atm_count)
		write (99, '(A2, "  ", F15.7, "  ", F15.7, "  ", F15.7)') element(i), atm_pos_curr(i, 1), atm_pos_curr(i, 2), atm_pos_curr(i, 3)
		i = i + 1
	    end do
	    close (99)	
    end if

    

    ! pricteni iterace
    iter = iter + 1
    
    open(unit = 1, file = "tmp_save")
	write (1, *) step, iter
	write (1, *) cfg_accepted, cfg_denied


	call random_seed(GET=seed_new(1:seed_count))

	i = 1
    	do while (i <= seed_count)
    	    write (1, *) seed_new(i)
    	
    	    i = i + 1
    	end do
	

	close (1)
	
    open (unit = 7, file = "tmp_simul_status")
	write (7, '(I1)') simul_status
	
	close (7)
call EXIT(return)

end program
